This file contains free-form notes.  Anyone working on this project,
please feel free to reformat this (including to something other than
Markdown) if you want.

# Examples

Note that some of these examples are still just pointers that will
need followup.

* The license now named the "Bootstrap Open Source License" (BOSL) was
  formerly known as the "Transitive Grace Period Public Licence"
  (TGPPL).  

  The 2020 blog post [Introducing BOSL, a radically new type of
  open-source
  license](https://electriccoin.co/blog/introducing-tgppl-a-radically-new-type-of-open-source-license/)
  discusses the license and gives some examples of its use.

  An earlier (2010) writeup about TGPPL from Ted T'so is
  [The Transitive Grace Period Public Licence: good ideas come
  around…](https://thunk.org/tytso/blog/2010/01/20/the-transitive-grace-period-public-licence-good-ideas-come-around/).

  [Tahoe-LAFS](https://github.com/tahoe-lafs/tahoe-lafs) seems to have
  a somewhat complicated (though still open source) licensing
  situation, but it appears to be also published under the TGPPL?

  And Zooko might be using BOSL or TGPPL for other things as well.
  (See also https://github.com/zooko/tgppl -- note that Richard
  Fontana is in the commit history there.)

* Aladdin Ghostscript

* Akka (BUSL) [license FAQ](https://www.lightbend.com/akka/license-faq)

  They moved to BSL last year; after 3 years, code switches from BSL
  to Apache 2.0.  From [their blog
  post](https://www.lightbend.com/blog/why-we-are-changing-the-license-for-akka):

    > ...
    > The new license for Akka is the Business Source License (BSL)
    > v1.1, with an additional usage grant to cover some open source
    > usage of Akka, such as part of the Play Framework. The BSL was
    > created by David Axmark and Michael Widenius and has been
    > adopted by MariaDB, Cockroach Labs, Sentry, Materialized, and
    > others.
    > 
    > The BSL is a “Source Available” license that freely allows using
    > the code for development and other non-production work such as
    > testing. Production use of the software requires a commercial
    > license from Lightbend. The commercial license will be available
    > at no charge for early-stage companies (less than US $25 million
    > in annual revenue). By enabling early-stage companies to use
    > Akka in production for free, we hope to continue to foster the
    > innovation synonymous with the startup adoption of Akka.
    > 
    > After 3 years, the BSL license indefinitely reverts to an Apache
    > 2.0 license. A [detailed FAQ](http://lightbend.com/akka/license-faq) is available to answer many of the
    > questions that you will have about the license change. You can
    > see our version of the BSL [here](https://lightbend.com/akka/license).
    > ...

* [Atom (text editor)](https://atom-editor.cc/blog/2014/05/06/atom-is-now-open-source/)

  (suggested by @Zaeraxa in reply to https://news.ycombinator.com/item?id=37745772)

* BerkeleyDB and Sleepycat?

* CockroachDB (BUSL) [licensing FAQs](https://www.cockroachlabs.com/docs/stable/licensing-faqs)

* FreeBSD netgraph

* [Ghostty](https://mitchellh.com/ghostty)

  (suggested by @Zaeraxa in reply to https://news.ycombinator.com/item?id=37745772)

* Modular/Mojo (a highly-anticipated project from Chris Lattner
  (creator of LLVM, Swift, and XLA/TensorFlow).

* GitLab

  The situation with GitLab is interesting.  They make some fairly
  specific [public
  commitments](https://handbook.gitlab.com/handbook/company/stewardship/#promises)
  that are somewhat DOSP-adjacent but are not themselves DOSP
  promises.  They also say they [default to moving features
  "down"ward](https://about.gitlab.com/company/pricing/#default-to-move-features-down),
  which in their nomenclature means toward the FOSS product; while
  that's not a binding commitment, they do seem in practice to be
  sticking to it.

  Overall, there does not appear to be an true DOSP activity here, but
  their way of operating probably warrants mention in the Appendix, as
  people interested in DOSP would also want to know about this.

* Hashicorp and BUSL
  - https://www.hashicorp.com/license-faq#Why-is-HashiCorp-making-this-change
  - https://www.hashicorp.com/blog/hashicorp-adopts-business-source-license

* MariaDB

* _MindLogger_ from Child Mind Institute
  - uses its self-rolled _"Delayed Open Source Attribution License"_ 
  - [license file on GH](https://github.com/ChildMindInstitute/mindlogger-applet-builder/blob/master/LICENSE.md)

* MkDocs

* North Road (geospatial software company) [projects](https://north-road.com/#)

  @jjgreen followed up in https://news.ycombinator.com/item?id=37745772
  to say: "North Road's SLYR (ESRI to QGIS Compatibility Suite) does
  that (and rather good code it is too).  https://north-road.com/slyr/ .
  I see North Road is actually on your list, but eventual openness not
  obvious.  I think that's clear for SLYR at least."

* Onivim 2 (was this unplanned?) [issue](https://github.com/onivim/oni2/issues/3771)
  see also https://v2.onivim.io/early-access-portal and
  https://github.com/onivim/oni2/issues/3811#issuecomment-910306404 for additional
  history

* Android (Google's eventual publication of changes to AOSP)

  If Google has typically been pretty regular about releasing stuff to
  Android Open Source Project, even if they haven't formally committed
  to that regularity, then that would be a kind of de facto DOSP.
  (Question: do they preserve the commit metadata for commits
  originally made in the private repository, so that when those
  commits are published, the exact delay between the creation of the
  commit and its becoming public can be seen?  Karl guesses that they
  do preserve all the metadata, but we should check.)

* OPSI ["co-funding"](https://www.opsi.org/de/dokumentation/opsi-lizenz-und-copyright) (see also [this forum link](https://forum.opsi.org/viewtopic.php?t=1193))

* [OTRS](https://www.znuny.org/en/blog/why) (open source -> delayed ->
  proprietary), but one person said that the announced delayed open release
  never actually happened.

* Pixelfed ["will be open sourced when we reach v1"](https://pixelfed.org/mobile-apps)

* [PKMN Classic Framework](https://github.com/mm201/pkmn-classic-framework)
  (a reverse-engineered third-party Pokémon game server?) has a conditional
  relicensing if the developer's official server instance goes offline in
  the future

* Qt (officially delayed releases in the past from Trolltech?)

* "searchcode" server under an "eventually open license" according to the post
  [GPL Time-bomb an interesting approach to #FOSS licensing](https://boyter.org/2016/08/gpl-time-bomb-interesting-approach-foss-licensing/)
  by Ben Boyter.

* [Sentry](https://github.com/getsentry/sentry/blob/master/LICENSE)
  (Business Source License (BUSL)); Codecov (also from Sentry) is also BUSL.

  See https://blog.sentry.io/lets-talk-about-open-source/.

* [Zed](https://zed.dev/blog/open-sourcing-zed-on-zed)

  (suggested by @Zaeraxa in reply to https://news.ycombinator.com/item?id=37745772)

# Not software

* Rockefeller University Press Journal of Cell Biology has a delayed
  open access policy with delayed relicensing of academic journal articles
  (although the end license is a noncommercial Creative Commons license
  so it would not be considered open source)

* Maybe there are other examples of delayed open access in journals with
  formal relicensing that would be considered fully open source (if the
  articles were software)?

# An annoying nomenclature problem

Even though we seem to think that the Business Source License should be
called BUSL, most of its end-users seem to refer to it as BSL!  It
may be awkward if we end up having a ton of citations where we say
things like "the project FooWare announced it was using BUSL in 2022
(see 'Announcing FooCorp's Switch to BSL')".

# Taxonomy

I (Seth) think there's a distinction to be made between these three cases:

* "automatic": licenses that are not open source licenses but that state
  (in the license text somewhere) that they automatically convert /
  automatically permit use and redistribution subject to a specified
  open source license after a period of time

* "manual": publicly announced practices of manually relicensing old codebase
  snapshots on a particular schedule, which depend on a person at the company
  explicitly making a delayed open source release

(In some sense, this is a potential distinction between a "delayed open
source licensing business practice" and a "delayed open source license".)

* "post-hoc" / "unscheduled": proprietary software that eventually was
  relicensed under an open source license, without a public statement of
  intent to do so at the time of its original publication, or without a
  published schedule for the conversion

I would include the former two in the scope of the report but not the
latter one (except to explain how it's different).  Some people have been
suggesting some of these cases (which can be fairly famous, like Netscape
Navigator!), but I think these should be thought of as more of a one-time
"change" than a "delay".

See also [Creative Commons Final Report: On the Viability and
Development of Springing
Licenses](https://creativecommons.org/wp-content/uploads/2018/07/Springing-licenses-FINAL.pdf).

Lawrence Rosen's book *Open Source Licensing: Software Freedom and Intellectual Property Law* uses the term "eventual source".

And Kyle Mitchell just published (as we were in the middle of doing
this research) the blog post [A Short, Simple Template for Scheduled
Relicensing](https://writing.kemitchell.com/2023/10/24/Scheduled-Relicensing),
that should probably at least be referenced from our report.

# Enforceability

The Creative Commons review seems to have been concerned that springing
licenses can have enforceability problems.  For their older Founders
Copyright project, they actually used a copyright assignment to the
Creative Commons nonprofit rather than (as they usually suggest for
public licensing of creative works) a unilateral license document.

(Was that because of concerns that copyright can't necessarily be
abandoned under U.S. law, or because of concerns that a licensor or the
licensor's heirs could withdraw or revoke the license if it were given
unilaterally with a delay?)

It might be helpful to understand how serious the enforceability concerns
are, although it doesn't seem that they've ever been tested in court, so
it may be hard to say anything definitive.

# Threads where we have posted

Look in the follow-ups in these threads (and subthreads thereof) for
more examples.  Please add other threads here too.

* https://kfogel.org/notice/AZSlnFS0GBe2x7Rd6u
* https://twitter.com/kfogel/status/1699104095976423795
* https://chat.opentechstrategies.com/#narrow/stream/2-general/topic/DOSP/near/172793
* https://news.ycombinator.com/item?id=37745772
* http://lists.opensource.org/pipermail/license-discuss_lists.opensource.org/2023-October/thread.html#22130

# Resources to check

* Free Software Business (fsb) mailing list archives at https://web.archive.org/web/20210000000000\*/http://www.crynwr.com/cgi-bin/ezmlm-cgi/0/

* The post [Why Open Source
  Matters](https://redmonk.com/sogrady/2023/08/03/why-opensource-matters/)
  from RedMonk (Aug 2023) points to some other examples.  (Also, it's
  a really good post, in Karl's opinion, not that anyone asked him,
  but hey, if you're editing the notes file then you get to insert
  your opinions.)

* Old games and libraries from [id Software](https://github.com/id-Software),
  but was this planned or announced?

# More people to contact as we're gathering examples

If your name should be on the list below but isn't, please [let us
know](https://code.librehq.com/ots/dosp-research/-/issues/new)!

* Deb Bryant
* Danese Cooper
* L. Peter Deutsch
* Raph Levien
* Zooko
* Your Name Here...

# Sources / Acknowledgements

* Simon Phipps
* Stefano Maffulli
* Nick Vidal
* Bastian Greshake Tzovaras
* Sam Ramji
* Heather Meeker
* Abby Kearns
